"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtScxml, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from collections.abc import Sequence

import PySide6.QtCore
import PySide6.QtScxml

class QScxmlDynamicScxmlServiceFactory(PySide6.QtScxml.QScxmlInvokableServiceFactory):
    """
    https://doc.qt.io/qt-6/qscxmldynamicscxmlservicefactory.html

    **Detailed Description**

    Dynamically resolved services are used when loading **SCXML**  content from
    files that a parent state machine requests at runtime, via the `srcexpr`
    attribute in the `<invoke>` element.
    """

    def __init__(
        self,
        invokeInfo: PySide6.QtScxml.QScxmlExecutableContent.InvokeInfo,
        names: Sequence[int],
        parameters: Sequence[PySide6.QtScxml.QScxmlExecutableContent.ParameterInfo],
        parent: PySide6.QtCore.QObject | None = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qscxmldynamicscxmlservicefactory.html#QScxmlDynam
        icScxmlServiceFactory

        **QScxmlDynamicScxmlServiceFactory::QScxmlDynamicScxmlServiceFactory(con
        st QScxmlExecutableContent::InvokeInfo & invokeInfo , const
        QList<QScxmlExecutableContent::StringId> & names , const
        QList<QScxmlExecutableContent::ParameterInfo> & parameters , QObject *
        parent = nullptr)**

        Creates a factory for dynamically resolved services, passing the
        attributes of the `<invoke>` element as **invokeInfo** , any `<param>`
        child elements as **parameters** , the content of the `names` attribute
        as **names** , and the **QObject**  parent **parent**.
        """
        ...
    def invoke(
        self, parentStateMachine: PySide6.QtScxml.QScxmlStateMachine
    ) -> PySide6.QtScxml.QScxmlInvokableService:
        """
        https://doc.qt.io/qt-6/qscxmldynamicscxmlservicefactory.html#invoke

        **[override virtual] QScxmlInvokableService
        *QScxmlDynamicScxmlServiceFactory::invoke(QScxmlStateMachine *
        parentStateMachine )**

        Reimplements: **QScxmlInvokableServiceFactory::invoke**
        (QScxmlStateMachine *parentStateMachine).
        """
        ...
